SGATCC/Areas/Coordenador/Controllers/AlunosController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using SGATCC.Areas.Coordenador.Models;
using SGATCC.Areas.Coordenador.ViewModel;
using SGATCC.Contexto;
using SGATCC.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Threading.Tasks;



namespace SGATCC.Areas.Coordenador.Controllers
{
    [Area("Coordenador")]
    [Authorize(Roles = "Coordenador")]
    public class AlunosController : Controller
    {
        private readonly ContextoSGATCC _context;

        public AlunosController(ContextoSGATCC context)
        {
            _context = context;
        }

        // GET: Alunos
        public async Task<IActionResult> Index()
        {
            return View(await _context.Alunos.Include(x => x.Curso).Include(x => x.Turno).ToListAsync());
        }

        // GET: Alunos/Details/5
        public async Task<IActionResult> Details(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var aluno = await _context.Alunos
                .FirstOrDefaultAsync(m => m.Id == id);
            if (aluno == null)
            {
                return NotFound();
            }

            return View(aluno);
        }

        // GET: Alunos/Create
        public IActionResult Create()
        {
            var dadosCursos = _context.Cursos.ToList();
            var listaCursos = new List<SelectListItem> { new SelectListItem { Text = "Selecione o Curso", Value = "" } };
            listaCursos.AddRange(dadosCursos.Select(x => new SelectListItem { Text = x.Descricao, Value = x.Id.ToString() }));

            ViewBag.lstCursos = listaCursos;
            return View();
        }

        public async Task<JsonResult> BuscarTurnosDoCurso(string cursoId)
        {
            var dadosTurma = await _context.Turmas
                .Where(x => x.CursoId == int.Parse(cursoId))
                .Include(x => x.Turno)
                .ToListAsync();

            var listaTurnos = dadosTurma.Select(x => new SelectListItem { Text = x.Turno.Descricao, Value = x.Turno.TurnoId.ToString() });

            return Json(listaTurnos);
        }

        // POST: Alunos/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(CriarAlunoViewModel viewModel)
        {
            if (ModelState.IsValid)
            {
                var aluno = new Aluno
                {
                    Nome = viewModel.Nome,
                    Matricula = $"MAT{DateTime.Today.Year}{viewModel.Nome.Substring(0, 3).ToUpper()}{viewModel.CPF.Substring(0,3)}",
                    Cpf = viewModel.CPF,
                    DataNascimento = viewModel.DataNascimento,
                    Sexo = viewModel.Sexo,
                    Telefone = viewModel.Telefone,
                    Email = viewModel.Email,
                    CursoId = int.Parse(viewModel.Curso),
                    TurnoId = int.Parse(viewModel.Turno)
                };
                _context.Add(aluno);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            return View(viewModel);
        }

        // GET: Alunos/Edit/5
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var aluno = await _context.Alunos.FindAsync(id);
            if (aluno == null)
            {
                return NotFound();
            }

            var alunoViewModel = new CriarAlunoViewModel
            {
                AlunoId = aluno.Id,
                Nome = aluno.Nome,
                CPF = aluno.Cpf,
                DataNascimento = aluno.DataNascimento,
                Email = aluno.Email,
                Sexo = aluno.Sexo,
                Telefone = aluno.Telefone,
                Curso = aluno.CursoId.ToString(),
                Turno = aluno.TurnoId.ToString()
            };

            var dadosCursos = _context.Cursos.ToList();
            var listaCursos = new List<SelectListItem> { new SelectListItem { Text = "Selecione o Curso", Value = "" } };
            listaCursos.AddRange(dadosCursos.Select(x => new SelectListItem { Text = x.Descricao, Value = x.Id.ToString() }));

            var dadosTurma = await _context.Turmas
                .Where(x => x.CursoId == int.Parse(alunoViewModel.Curso))
                .Include(x => x.Turno)
                .ToListAsync();

            var listaTurnos = new List<SelectListItem> { new SelectListItem { Text = "Selecione", Value = "" }};
            listaTurnos.AddRange(dadosTurma.Select(x => new SelectListItem { Text = x.Turno.Descricao, Value = x.Turno.TurnoId.ToString()}));
            ViewBag.lstCursos = listaCursos;
            ViewBag.lstTurno = listaTurnos;
            return View(alunoViewModel);
        }

        // POST: Alunos/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, CriarAlunoViewModel viewModel)
        {
            if (id != viewModel.AlunoId)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    var aluno = _context.Alunos.FirstOrDefault(x => x.Id == id);
                    aluno.Nome = viewModel.Nome;
                    aluno.Cpf = viewModel.CPF;
                    aluno.DataNascimento = viewModel.DataNascimento;
                    aluno.Sexo = viewModel.Sexo;
                    aluno.Telefone = viewModel.Telefone;
                    aluno.Email = viewModel.Email;
                    aluno.CursoId = int.Parse(viewModel.Curso);
                    aluno.TurnoId = int.Parse(viewModel.Turno);

                    
                    _context.Update(aluno);
                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!AlunoExists(viewModel.AlunoId))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            return View(viewModel);
        }

        // GET: Alunos/Delete/5
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var aluno = await _context.Alunos
                .FirstOrDefaultAsync(m => m.Id == id);
            if (aluno == null)
            {
                return NotFound();
            }

            return View(aluno);
        }

        // POST: Alunos/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var aluno = await _context.Alunos.FindAsync(id);
            _context.Alunos.Remove(aluno);
            await _context.SaveChangesAsync();
            return RedirectToAction(nameof(Index));
        }

        private bool AlunoExists(int id)
        {
            return _context.Alunos.Any(e => e.Id == id);
        }
    }
}

SGATCC/Areas/Coordenador/Controllers/CursosController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using SGATCC.Areas.Coordenador.Models;
using SGATCC.Contexto;
using SGATCC.Models;
using System.Linq;
using System.Threading.Tasks;

namespace SGATCC.Areas.Coordenador.Controllers
{
    [Area("Coordenador")]
    [Authorize(Roles = "Coordenador")]
    public class CursosController : Controller
    {
        private readonly ContextoSGATCC _context;

        public CursosController(ContextoSGATCC context)
        {
            _context = context;
        }

        // GET: Cursos
        public async Task<IActionResult> Index()
        {
            return View(await _context.Cursos.ToListAsync());
        }

        // GET: Cursos/Details/5
        public async Task<IActionResult> Details(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var curso = await _context.Cursos
                .FirstOrDefaultAsync(m => m.Id == id);
            if (curso == null)
            {
                return NotFound();
            }

            return View(curso);
        }

        // GET: Cursos/Create
        public IActionResult Create()
        {
            return View();
        }

        // POST: Cursos/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("CursoId,Descricao,CargaHorariaTotal")] Curso curso)
        {
            if (ModelState.IsValid)
            {
                _context.Cursos.Add(curso);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            return View(curso);
        }

        // GET: Cursos/Edit/5
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var curso = await _context.Cursos.FindAsync(id);
            if (curso == null)
            {
                return NotFound();
            }
            return View(curso);
        }

        // POST: Cursos/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, [Bind("CursoId,Descricao,CargaHorariaTotal")] Curso curso)
        {
            if (id != curso.Id)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    _context.Cursos.Update(curso);
                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!CursoExists(curso.Id))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            return View(curso);
        }

        // GET: Cursos/Delete/5
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var curso = await _context.Cursos
                .FirstOrDefaultAsync(m => m.Id == id);
            if (curso == null)
            {
                return NotFound();
            }

            return View(curso);
        }

        // POST: Cursos/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var curso = await _context.Cursos.FindAsync(id);
            _context.Cursos.Remove(curso);
            await _context.SaveChangesAsync();
            return RedirectToAction(nameof(Index));
        }

        private bool CursoExists(int id)
        {
            return _context.Cursos.Any(e => e.Id == id);
        }
    }
}

SGATCC/Views/Shared/_LayoutIdentity.cshtml
@using Microsoft.AspNetCore.Identity
@using Microsoft.AspNetCore.Identity.EntityFrameworkCore
@inject SignInManager<IdentityUser> SignInManager
@inject UserManager<IdentityUser> UserManager

@{
    var user = await UserManager.GetUserAsync(User);
}

<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - SGA</title>

    <environment include="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
              asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute"
              crossorigin="anonymous"
              integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" />
    </environment>

    <link rel="stylesheet" href="~/css/site.css" />

    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">



    <!-- Custom fonts for this template-->
    <link href="~/vendor/fontawesome-free/css/all.min.css" rel="stylesheet" type="text/css">
    <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

    <!-- Custom styles for this template-->
    <link href="~/css/sb-admin-2.min.css" rel="stylesheet">

</head>

<body>
    <header>
    </header>

    <!-- Page Wrapper -->
    <div id="wrapper">



        <!-- Sidebar -->
        <ul class="navbar-nav bg-gradient-primary sidebar sidebar-dark accordion" id="accordionSidebar">

            <!-- Sidebar - Brand -->
            <a class="sidebar-brand d-flex align-items-center justify-content-center" asp-area="Coordenador" asp-controller="Home" asp-action="Index">
                <div class="sidebar-brand-icon rotate-n-15">
                    <i class="fas fa-cogs"></i>
                </div>
                <div class="sidebar-brand-text mx-3">SGA</div>
            </a>

            <!-- Divider -->
            <hr class="sidebar-divider">

            <!-- Heading -->
            <div class="sidebar-heading">
                Ações
            </div>

            <!-- Nav Item - Pages Collapse Menu -->
            @*CADASTRO*@
            <li class="nav-item">
                <a class="nav-link collapsed" href="#" data-toggle="collapse" data-target="#collapseTwo" aria-expanded="true" aria-controls="collapseTwo">
                    <i class="fas fa-fw fa-address-card"></i>
                    <span>Cadastrar</span>
                </a>
                <div id="collapseTwo" class="collapse" aria-labelledby="headingTwo" data-parent="#accordionSidebar">
                    <div class="bg-white py-2 collapse-inner rounded">
                        <a class="collapse-item" asp-area="Coordenador" asp-controller="Alunos" asp-action="Create">Aluno</a>
                        <a class="collapse-item" asp-area="Coordenador" asp-controller="Professores" asp-action="Create">Professor</a>
                        <a class="collapse-item" asp-area="Coordenador" asp-controller="Cursos" asp-action="Create">Curso</a>
                        <a class="collapse-item" asp-area="Coordenador" asp-controller="Turmas" asp-action="Create">Turma</a>
                        <a class="collapse-item" asp-area="Coordenador" asp-controller="Disciplinas" asp-action="Create">Disciplina</a>
                        @*<a class="collapse-item" href="https://localhost:44370/Historicos/Create">Historico</a>*@
                    </div>
                </div>
            </li>

            @*LANÇAMENTOS*@
            <li class="nav-item">
                <a class="nav-link collapsed" href="#" data-toggle="collapse" data-target="#collapseLancamentos" aria-expanded="true" aria-controls="collapseTwo">
                    <i class="fas fa-fw fa-address-card"></i>
                    <span>Lançamentos</span>
                </a>
                <div id="collapseLancamentos" class="collapse" aria-labelledby="headingTwo" data-parent="#accordionSidebar">
                    <div class="bg-white py-2 collapse-inner rounded">
                        <a class="collapse-item" asp-area="Coordenador" asp-controller="NotaAlunos" asp-action="Create">Notas</a>
                        <a class="collapse-item" asp-area="Coordenador" asp-controller="FrequenciaAlunos" asp-action="Create">Chamada</a>
                    </div>
                </div>
            </li>

            @*RELATÓRIOS*@

            <li class="nav-item">
                <a class="nav-link collapsed" href="#" data-toggle="collapse" data-target="#collapseRelatorios" aria-expanded="true" aria-controls="collapseTwo">
                    <i class="fas fa-cog"></i>
                    <span>Relatórios</span>
                </a>
                <div id="collapseRelatorios" class="collapse" aria-labelledby="headingTwo" data-parent="#accordionSidebar">
                    <div class="bg-white py-2 collapse-inner rounded">
                        <a class="collapse-item" asp-area="Coordenador" asp-controller="Alunos" asp-action="Index">Lista de Aluno</a>
                        <a class="collapse-item" asp-area="Coordenador" asp-controller="Professores" asp-action="Index">Lista de Professor</a>
                        <a class="collapse-item" asp-area="Coordenador" asp-controller="Cursos" asp-action="Index">Lista de Curso</a>
                        <a class="collapse-item" asp-area="Coordenador" asp-controller="Turmas" asp-action="Index">Lista de Turma</a>
                        <a class="collapse-item" asp-area="Coordenador" asp-controller="Disciplinas" asp-action="Index">Lista de Disciplina</a>
                    </div>
                </div>
            </li>

            <!-- Divider -->
            <hr class="sidebar-divider d-none d-md-block">

            <!-- Sidebar Toggler (Sidebar) -->
            <div class="text-center d-none d-md-inline">
                <button class="rounded-circle border-0" id="sidebarToggle"></button>
            </div>

        </ul>
        <!-- End of Sidebar -->
        <!-- Content Wrapper -->
        <div id="content-wrapper" class="d-flex flex-column">
            <!-- Topbar Navbar -->
            <ul class="navbar-nav ml-auto">

                <!-- Nav Item - Search Dropdown (Visible Only XS) -->
                <li class="nav-item dropdown no-arrow d-sm-none">
                    <a class="nav-link dropdown-toggle" href="#" id="searchDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <i class="fas fa-search fa-fw"></i>
                    </a>
                    <!-- Dropdown - Messages -->
                    <div class="dropdown-menu dropdown-menu-right p-3 shadow animated--grow-in" aria-labelledby="searchDropdown">
                        <form class="form-inline mr-auto w-100 navbar-search">
                            <div class="input-group">
                                <input type="text" class="form-control bg-light border-0 small" placeholder="Search for..." aria-label="Search" aria-describedby="basic-addon2">
                                <div class="input-group-append">
                                    <button class="btn btn-primary" type="button">
                                        <i class="fas fa-search fa-sm"></i>
                                    </button>
                                </div>
                            </div>
                        </form>
                    </div>
                </li>



                <div class="topbar-divider d-none d-sm-block"></div>

                <!-- Nav Item - User Information -->
            </ul>

            </nav>
            <!-- End of Topbar -->
            <!-- Main Content -->
            <!-- Topbar -->
            <nav class="navbar navbar- navbar-light navbar-right bg-white topbar mb-4 static-top shadow justify-content-end">
                <div>
                    <label>Olá @user.UserName &nbsp;</label>

                    <a class="btn btn-defaut" asp-controller="Account" asp-action="Logout" title="Sair">
                        <i class="fas fa-sign-out-alt" style="color:red"></i>
                    </a>
                </div>
            </nav>
            <div id="content">
                <div class="container">
                    <partial name="_CookieConsentPartial" />
                    <main role="main" class="pb-3">
                        @RenderBody()
                    </main>
                </div>
            </div>
            <!-- End of Content Wrapper -->

        </div>
        <footer></footer>
        <!-- End of Footer -->
        <!-- End of Page Wrapper -->
        <!-- Scroll to Top Button-->
        <a class="scroll-to-top rounded" href="#page-top">
            <i class="fas fa-angle-up"></i>
        </a>



        <!-- Bootstrap core JavaScript-->
        <script src="~/vendor/jquery/jquery.min.js"></script>
        <script src="~/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>

        <!-- Core plugin JavaScript-->
        <script src="~/vendor/jquery-easing/jquery.easing.min.js"></script>

        <!-- Custom scripts for all pages-->
        <script src="~/js/sb-admin-2.min.js"></script>

        <!-- Page level plugins -->
        <script src="~/vendor/chart.js/Chart.min.js"></script>

        <!-- Page level custom scripts -->
        <script src="~/js/demo/chart-area-demo.js"></script>
        <script src="~/js/demo/chart-pie-demo.js"></script>
    </div>

    <footer></footer>

    <environment include="Development">
        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.js"></script>
    </environment>
    <environment exclude="Development">
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery"
                crossorigin="anonymous"
                integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8=">
        </script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
                crossorigin="anonymous"
                integrity="sha384-xrRywqdh3PHs8keKZN+8zzc5TX0GRTLCcmivcbNJWm2rs5C8PRhcEn3czEjhAO9o">
        </script>
    </environment>
    <script src="~/js/site.js" asp-append-version="true"></script>

    @RenderSection("Scripts", required: false)
</body>
</html>